#!/bin/sh
## ------------------------------------------------------------------------------
## In einem Ordner wird jede NAS-Datei einzeln in ein Zip-Archiv komprimiert.
## Die ursprngliche NAS-Datei wird dabei entfernt: Parameter "-m" (move).
## ------------------------------------------------------------------------------
## Stand: 
##  2015-01-12  PostNAS 08
##  2016-02-03  Fuer Kompatibilitt mit dem norGIS_ALKIS_Import darf die Datei nicht "*.xml.zip" heien

  echo "**************************************************"
  echo "**  NAS-Dateien in einem Ordner einzeln zippen  **"
  echo "**************************************************"

  ORDNER=$1
  if [ $ORDNER = '' ]
  then
    echo "Parameter 1 'Ordner' fehlt"
    $ORDNER = '.'
    exit 1
  fi

  echo "*** Ordner = '${ORDNER}'"
  cd ${ORDNER}
  echo " "
  ls

  for nasdatei in *.xml ; do 
    echo "  * Datei: " $nasdatei

    # Endung .xml abschneiden
    BASENAME=$(basename $nasdatei .xml)

    #      Archiv           NAS-Datei
    zip -m ${BASENAME}.zip  ${nasdatei}
  done

  ls
  echo "** E n d e  -  Zippen des Ordners '${ORDNER}'"
