<?php
/*	alkishaus.php - viele Daten zu EINEM ALKIS-Gebäude-Objekt
	ALKIS-Buchauskunft, Kommunales Rechenzentrum Minden-Ravensberg/Lippe (Lemgo).

	Version:
	2016-02-24 Version fuer norGIS-ALKIS-Import

	ToDo:
	- sinnvolle Sortierung und Gruppierung der Felder
	- geometrische Suche nach FS, auf denen das Haus steht
	- Template im WMS auf Ebene Gebäude hierhin verknüpfen.
	- Auch diese Relationen abbilden:
		ax_gebaeude >gehoertZu> ax_gebaeude  (ringförmige Verbindung Gebäudekomplex)
		ax_gebaeude (umschliesst) ax_bauteil
		ax_gebaeude >gehoert> ax_person  (Ausnahme)
*/
session_start();
$id="n";
$cntget = extract($_GET);
require_once("alkis_conf_location.php");
if ($auth == "mapbender") {require_once($mapbender);}
include("alkisfkt.php");
$keys = isset($_GET["showkey"]) ? $_GET["showkey"] : "n";
if ($keys == "j") {$showkey=true;} else {$showkey=false;}
if ($allfld == "j") {$allefelder=true;} else {$allefelder=false;}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<meta name="author" content="b600352" >
	<meta http-equiv="cache-control" content="no-cache">
	<meta http-equiv="pragma" content="no-cache">
	<meta http-equiv="expires" content="0">
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>ALKIS Daten zum Haus</title>
	<link rel="stylesheet" type="text/css" href="alkisauszug.css">
	<link rel="shortcut icon" type="image/x-icon" href="ico/Haus.ico">
	<style type='text/css' media='print'>
		.noprint {visibility: hidden;}
	</style>
</head>
<body>
<?php

$con = pg_connect("host=".$dbhost." port=" .$dbport." dbname=".$dbname." user=".$dbuser." password=".$dbpass);
if (!$con) echo "<p class='err'>Fehler beim Verbinden der DB</p>\n";

// G e b a e u d e
// ++ auch .d-Spalten der alkis_werte? 
$sqlg ="SELECT g.gml_id, g.name, g.bauweise, g.gebaeudefunktion, g.anzahlderoberirdischengeschosse AS aog, g.anzahlderunterirdischengeschosse AS aug, 
g.lagezurerdoberflaeche, g.dachgeschossausbau, g.zustand, array_to_string(g.weiteregebaeudefunktion, ',') AS wgf, g.dachform, g.hochhaus, g.objekthoehe, g.geschossflaeche, g.grundflaeche, g.umbauterraum, g.baujahr, g.dachart, g.qualitaetsangaben, 
h.v bbauw, u.v AS bfunk, z.v AS zustandv, d.v AS bdach, a.v AS dgaus, o.v AS oflv,
round(st_area(g.wkb_geometry)::numeric,2) AS gebflae FROM ax_gebaeude g 
LEFT JOIN alkis_wertearten h ON cast(g.bauweise AS character varying)=h.k AND h.element='ax_gebaeude' AND h.bezeichnung='bauweise'
LEFT JOIN alkis_wertearten u ON cast(g.gebaeudefunktion AS character varying)=u.k AND u.element='ax_gebaeude' AND u.bezeichnung='gebaeudefunktion'
LEFT JOIN alkis_wertearten z ON cast(g.zustand AS character varying)=z.k AND z.element='ax_gebaeude' AND z.bezeichnung='zustand'
LEFT JOIN alkis_wertearten d ON cast(g.dachform AS character varying)=d.k AND d.element='ax_gebaeude' AND d.bezeichnung='dachform'
LEFT JOIN alkis_wertearten a ON cast(g.dachgeschossausbau AS character varying)=a.k AND a.element='ax_gebaeude' AND a.bezeichnung='dachgeschossausbau'
LEFT JOIN alkis_wertearten o ON cast(g.lagezurerdoberflaeche AS character varying)=o.k AND o.element='ax_gebaeude' AND o.bezeichnung='lagezurerdoberflaeche'
WHERE g.gml_id= $1 AND g.endet IS NULL;";

$v = array($gmlid);
$resg = pg_prepare("", $sqlg);
$resg = pg_execute("", $v);
if (!$resg) {
	echo "\n<p class='err'>Fehler bei Geb&auml;ude.<br>".pg_last_error()."</p>\n";
	if ($debug > 2) {echo "<p class='dbg'>SQL=<br>".$sqlg."<br>$1 = gml_id = '".$gmlid."'</p>";}
}

// Balken
echo "<p class='geb'>ALKIS Haus ".$gmlid."&nbsp;</p>\n"; // ++ Kennzeichen?

echo "\n<h2><img src='ico/Haus.png' width='16' height='16' alt=''> Haus (Geb&auml;ude)</h2>\n";

// Kennzeichen in Rahmen 
// - Welches Kennzeichen zum Haus ?
echo "\n<hr>";
// Umschalter: auch leere Felder ausgeben?
echo "<p class='nwlink noprint'>";
echo "<a class='nwlink' href='".$_SERVER['PHP_SELF']."?gkz=".$gkz."&amp;gmlid=".$gmlid;
	if ($showkey) {echo "&amp;showkey=j";} else {echo "&amp;showkey=n";}
	if ($allefelder) {echo "&amp;allfld=n'>nur Felder mit Inhalt";} 
	else {echo "&amp;allfld=j'>auch leere Felder";}
echo "</a></p>";

$gebnr = 0;

while($rowg = pg_fetch_array($resg)) { // Schleife, kann aber nur EIN Haus sein.
	$gebnr++;
	echo "\n<table class='geb'>"
	."\n<tr>\n"
		."\n\t<td class='head' title=''>Attribut</td>"
		."\n\t<td class='head' title=''>Wert</td>"
	."\n</tr>";

	$aog=$rowg["aog"];
	$aug=$rowg["aug"];
	$hoh=$rowg["hochhaus"];
	$nam=$rowg["name"]; // Gebaeude-Name
	$bfunk=$rowg["bfunk"];

	$baw=$rowg["bauweise"];
	$bbauw=$rowg["bbauw"];

	$ofl=$rowg["lagezurerdoberflaeche"]; // Key
	$oflv=$rowg["oflv"]; // Value

	$dga=$rowg["dachgeschossausbau"]; // Key
	$dgav=$rowg["dgaus"]; // Value

	$zus=$rowg["zustand"]; // Key
	$zusv=$rowg["zustandv"]; // Value

	$wgf=$rowg["wgf"]; // Array-> kommagetrennte Liste

	$daf=$rowg["dachform"]; // Key
	$dach=$rowg["bdach"]; // Value

	$hho=$rowg["objekthoehe"];
	$gfl=$rowg["geschossflaeche"];
	$grf=$rowg["grundflaeche"];
	$ura=$rowg["umbauterraum"];
	$bja=$rowg["baujahr"];
	$daa=$rowg["dachart"];
	$qag=$rowg["qualitaetsangaben"];

	if (($nam != "") OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Name\" ist der Eigenname oder die Bezeichnung des Geb&auml;udes.'>Name</td>"
			."\n\t<td>".$nam."</td>"
		."\n</tr>";
	}

	// 0 bis N   L a g e bezeichnungen mit Haus- oder Pseudo-Nummer

	// HAUPTgebäude
	$sqll ="SELECT 'm' AS ltyp, l.gml_id AS gmllag, s.lage, s.bezeichnung, l.hausnummer, '' AS laufendenummer FROM ax_gebaeude g
	JOIN ax_lagebezeichnungmithausnummer l ON l.gml_id=ANY(g.zeigtauf)
	JOIN ax_lagebezeichnungkatalogeintrag s ON l.kreis=s.kreis AND l.gemeinde=s.gemeinde AND l.lage=s.lage
	WHERE g.gml_id= $1 AND g.endet IS NULL AND l.endet IS NULL";
	// oder NEBENgebäude
	$sqll.=" UNION 
	SELECT 'p' AS ltyp, l.gml_id AS gmllag, s.lage, s.bezeichnung, l.pseudonummer AS hausnummer, l.laufendenummer
	FROM ax_gebaeude g
	JOIN ax_lagebezeichnungmitpseudonummer l ON l.gml_id=g.hat
	JOIN ax_lagebezeichnungkatalogeintrag s ON l.kreis=s.kreis AND l.gemeinde=s.gemeinde AND l.lage=s.lage
	WHERE g.gml_id= $1 AND g.endet IS NULL AND l.endet IS NULL ";

	$sqll.="ORDER BY bezeichnung, hausnummer ;";

	$v = array($gmlid);
	$resl = pg_prepare("", $sqll);
	$resl = pg_execute("", $v);
	if (!$resl) {
		echo "\n<p class='err'>Fehler bei Lage mit HsNr.</p>\n";
		if ($debug > 2) {echo "<p class='dbg'>SQL=<br>".$sqll."<br>$1 = gml_id = '".$gmlid."'</p>";}
	}
	$zhsnr=0;
	while($rowl = pg_fetch_array($resl)) { // LOOP: Lagezeilen
		$zhsnr++;
		$ltyp=$rowl["ltyp"]; // Lagezeilen-Typ
		$skey=$rowl["lage"]; // Str.-Schluessel
		$snam=htmlentities($rowl["bezeichnung"], ENT_QUOTES, "UTF-8"); // -Name
		$hsnr=$rowl["hausnummer"];
		$hlfd=$rowl["laufendenummer"];
		$gmllag=$rowl["gmllag"];

		if ($zhsnr == 1) {
			echo "\n<tr>\n\t<td title='Lage mit Hausnummer oder Pseudonummer'>Adresse</td>";
			echo "\n\t<td>";
		}
		echo "\n\t\t<img src='ico/Lage_mit_Haus.png' width='16' height='16' alt=''>&nbsp;";
		if ($showkey) {echo "<span class='key'>(".$skey.")</span>&nbsp;";}			
		echo "\n\t\t<a title='Hausnummer' href='alkislage.php?gkz=".$gkz."&amp;gmlid=".$gmllag."&amp;ltyp=".$ltyp."'>";
			echo $snam."&nbsp;".$hsnr;
			if ($ltyp == "p") { echo ", lfd.Nr ".$hlfd;}
		echo "</a><br>";
	} // Ende Loop Lagezeilen m.H.
	if ($zhsnr > 0) {echo "\n\t</td>\n</tr>";}

	echo "\n<tr>"
		."\n\t<td title='\"Geb&auml;udefunktion\" ist die zum Zeitpunkt der Erhebung vorherrschend funktionale Bedeutung des Geb&auml;udes'>Funktion</td>"
		."\n\t<td>";
		if ($showkey) {echo "<span class='key'>".$rowg["gebaeudefunktion"]."</span>&nbsp;";}
		echo $bfunk."</td>"
	."\n</tr>";
	if ($baw != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Bauweise\" ist die Beschreibung der Art der Bauweise.'>Bauweise</td>"
			."\n\t<td>";
			if ($showkey) {echo "<span class='key'>".$baw."</span>&nbsp;";}
			echo $bbauw."</td>"
		. "\n</tr>";
	}
	if ($aog != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='Anzahl oberirdischer Geschosse'>Geschosse</td>"
			. "\n\t<td>".$aog."</td>"
		. "\n</tr>";
	}
	if ($aug != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='Anzahl unterirdischer Geschosse'>U-Geschosse</td>"
			. "\n\t<td>".$aug."</td>"
		. "\n</tr>";
	}
	if ($hoh != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Hochhaus\" ist ein Geb&auml;ude, das nach Geb&auml;udeh&ouml;he und Auspr&auml;gung als Hochhaus zu bezeichnen ist. F&uuml;r Geb&auml;ude im Geschossbau gilt dieses i.d.R. ab 8 oberirdischen Geschossen, f&uuml;r andere Geb&auml;ude ab einer Geb&auml;udeh&ouml;he von 22 m.'>Hochhaus</td>";
			echo "\n\t<td>".$hoh."</td>";
		echo "\n</tr>";
	}
	if ($ofl != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Lage zur Erdoberfl&auml;che\" ist die Angabe der relativen Lage des Geb&auml;udes zur Erdoberfl&auml;che. Diese Attributart wird nur bei nicht ebenerdigen Geb&auml;uden gef&uuml;hrt.'>Lage zur Erdoberfl&auml;che</td>"
			."\n\t<td>";
			if ($showkey) {echo "<span class='key'>".$ofl."</span>&nbsp;";}
			echo $oflv;"</td>"
		."\n</tr>";
	}
	if ($dga != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Dachgeschossausbau\" ist ein Hinweis auf den Ausbau bzw. die Ausbauf&auml;higkeit des Dachgeschosses.'>Dachgeschossausbau</td>"
			."\n\t<td>";
			if ($showkey) {echo "<span class='key'>".$dga."</span>&nbsp;";}
			echo $dgav."</td>"
		."\n</tr>";
	}
	if ($zus != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Zustand\" beschreibt die Beschaffenheit oder die Betriebsbereitschaft von \"Geb&auml;ude\". Diese Attributart wird nur dann optional gef&uuml;hrt, wenn der Zustand des Geb&auml;udes vom nutzungsf&auml;higen Zustand abweicht.'>Zustand</td>"
			."\n\t<td>";
			if ($showkey) {echo "<span class='key'>".$zus."</span>&nbsp;";}
			echo $zusv."</td>"
		."\n</tr>";
	}
	// Suche Testfall: SELECT * FROM ax_gebaeude WHERE NOT weiteregebaeudefunktion IS NULL;
	// Keiner zu finden. Das folgende ungetestet:
	if ($wgf != "" OR $allefelder) { // "weiteregebaeudefunktion" ist ein Array
		echo "\n<tr>"
			."\n\t<td title='\"Weitere Geb&auml;udefunktion\" ist die Funktion, die ein Geb&auml;ude neben der dominierenden Geb&auml;udefunktion hat.'>Weitere Geb&auml;udefunktionen</td>\n\t<td>";
			if ($wgf != "") { // Kommagetrennte Liste aus Array
				$sqlw="SELECT k, v, d FROM alkis_wertearten WHERE k IN ( $1 ) AND element='ax_gebaeude' AND bezeichnung='weiteregebaeudefunktion' ORDER BY k;";
				$v = array($wgf);
				$resw = pg_prepare("", $sqlw);
				$resw = pg_execute("", $v);
				if (!$resw) {
					echo "\n<p class='err'>Fehler bei Geb&auml;ude - weitere Funktion.</p>\n";
					if ($debug > 2) {echo "<p class='dbg'>SQL=<br>".$sqlw."<br>$1 = Werteliste = '".$wgf."'</p>";}
				}
				$zw=0;
				while($roww = pg_fetch_array($resw)) { // LOOP: w.Funktion
					if ($zw > 0) {echo "<br>";}
					if ($showkey) {echo "<span class='key'>".$roww["k"]."</span>&nbsp;";}
					echo "<span title='".$roww["d"]."'>".$roww["v"]."</span>";
					$zw++;
			   }
			}
			echo "</td>"
		."\n</tr>";
	}
	if ($daf != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Dachform\" beschreibt die charakteristische Form des Daches.'>Dachform</td>"
			."\n\t<td>";
			if ($showkey) {echo "<span class='key'>".$daf."</span>&nbsp;";}
			echo $dach."</td>"
		."\n</tr>";
	}
	if ($hho != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Objekth&ouml;he\" ist die H&ouml;hendifferenz in [m] zwischen dem h&ouml;chsten Punkt der Dachkonstruktion und der festgelegten Gel&auml;ndeoberfl&auml;che des Geb&auml;udes.'>Objekth&ouml;he</td>"
			."\n\t<td>".$hho."</td>"
		."\n</tr>";
	}
	if ($gfl != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Geschossfl&auml;che\" ist die Geb&auml;udegeschossfl&auml;che in [qm].'>Geschossfl&auml;che</td>"
			."\n\t<td>";
			if ($gfl != "") {echo $gfl." m&#178;";}
			echo "</td>"
		."\n</tr>";
	}
	if ($grf != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Grundfl&auml;che\" ist die Geb&auml;udegrundfl&auml;che in [qm].'>Grundfl&auml;che</td>"
			."\n\t<td>";
			if ($grf != "") {echo $grf." m&#178;";}
		echo "\n</tr>";
	}
	if ($ura != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Umbauter Raum\" ist der umbaute Raum [Kubikmeter] des Geb&auml;udes.'>Umbauter Raum</td>"
			."\n\t<td>".$ura."</td>"
		."\n</tr>";
	}
	if ($bja != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Baujahr\" ist das Jahr der Fertigstellung oder der baulichen Ver&auml;nderung des Geb&auml;udes.'>Baujahr</td>"
			."\n\t<td>".$bja."</td>"
		."\n</tr>";
	}
	if ($daa != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='\"Dachart\" gibt die Art der Dacheindeckung (z.B. Reetdach) an.'>Dachart</td>"
			."\n\t<td>".$daa."</td>"
		."\n</tr>";
	}
	if ($qag != "" OR $allefelder) {
		echo "\n<tr>"
			."\n\t<td title='Angaben zur Herkunft der Informationen (Erhebungsstelle). Die Information ist konform zu den Vorgaben aus ISO 19115 zu repr&auml;sentieren.'>Qualit&auml;tsangaben</td>"
			."\n\t<td>".$qag."</td>"
		."\n</tr>";
	}
	echo "\n</table>";
}
if ($gebnr == 0) {echo "<p class='err'><br>Kein Geb&auml;ude gefunden<br>&nbsp;</p>";}

// ++ ToDo: Verschnitt mit FS?

?>

<form action=''>
	<div class='buttonbereich noprint'>
	<hr>
		<a title="zur&uuml;ck" href='javascript:history.back()'><img src="ico/zurueck.png" width="16" height="16" alt="zur&uuml;ck"></a>&nbsp;
		<a title="Drucken" href='javascript:window.print()'><img src="ico/print.png" width="16" height="16" alt="Drucken"></a>&nbsp;
	</div>
</form>

<?php footer($gmlid, $_SERVER['PHP_SELF']."?", ""); ?>

</body>
</html>
